#include <avr/io.h>

#include "taster.h"
#include "ports.h"

volatile uint8_t taster;
taste_t tasten[NUM_TASTER+1];

void get_taster (uint8_t num) 
{
    taste_t *ptast = tasten + num;
    uint8_t tast = 0;

    uint8_t taster_old = ptast->old;
 
    // welche Taster sind gedrckt?
    if (num == KEY_UP)      if (IS_CLEAR (PORT_TAST0))  tast = 1;
    if (num == KEY_MITTE)   if (IS_CLEAR (PORT_TAST1))  tast = 1;
    if (num == KEY_DOWN)    if (IS_CLEAR (PORT_TAST2))  tast = 1;
 
    // Was wurde gedrckt/losgelassen...?
    uint8_t pressed =  taster_old &  tast;
    uint8_t press   = ~taster_old &  tast;
    uint8_t release =  taster_old & ~tast;

    ptast->old = tast;
 
    tast = 0;
 
    uint8_t mode  = ptast->mode;
    uint8_t delay = ptast->delay;
 
    num++;
 
    if (press & 1)
    {
        delay = 0;
  
        if (mode != KM_LONG)
            tast = num;
    }
    else if (pressed & 1)
    {
        if (delay < 0xfe)
            delay++;
    }
    else if (release & 1)
    {
        if (mode == KM_LONG && delay != 0xff)
            tast = num;
    }

    ///////////
    
    if (mode == KM_LONG)
    {
        if (delay == KEYDELAY_LONG)
        {
            tast = KEY_LONG + num;
            delay = 0xff;
        }
    }
    else if (mode == KM_REPEAT)
    {
        if (delay == KEYREPEAT_DELAY)
        {
            tast = num;
            delay = KEYREPEAT_DELAY - KEYREPEAT;
        }
    }

    if (taster == 0)
        taster = tast;
  
    ptast->delay = delay;
}
